Sketcher SketchObject

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Sketcher SketchObject and the translation is 100% complete.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano

Introduction

Sketcher Sketch.svg

Un Sketcher SketchObject, ou formellement un Sketcher::SketchObject, est l'élément de base pour créer des objets 2D avec l'Atelier Sketcher.

Sketcher::SketchObject est dérivé de Part Part2DObject. Cela signifie qu'il s'agit d'un objet Part Feature spécialisé dans la géométrie 2D. Comme Part2DObject, l'objet SketchObject peut être attaché à des plans et à des faces. En plus de cela, SketchObject peut gérer les contraintes géométriques des lignes et des courbes qui y sont dessinées.

FreeCAD core objects.svg

Schéma simplifié des relations entre les objets principaux dans FreeCAD. La classe Sketcher::SketchObject est spécialisée pour les formes 2D et comprend en plus une extension pour gérer les contraintes géométriques de ses éléments.


Utilisation

  1. Basculez vers l'Atelier Sketcher.
  2. Appuyez sur Sketcher NewSketch.svg Sketcher Nouvelle esquisse.
  3. Sélectionnez une Orientation de l'esquisse: plan XY, plan XZ ou plan YZ. Vous pouvez également choisir d'Inverser la direction et donner une valeur de Décalage.
  4. Appuyez sur OK.

Bien que SketchObject puisse être utilisé seul pour dessiner sur un plan, il est le plus souvent utilisé conjointement avec Atelier PartDesign pour créer des solides extrudés.

  1. Basculer vers le Atelier PartDesign.
  2. Appuyez sur PartDesign Body.svg PartDesign Corps.
  3. Appuyez sur PartDesign NewSketch.svg PartDesign Nouvelle esquisse.
  4. Fonction sélectionnée: XY_Plane (Plan de base), XZ_Plane (Plan de base) ou YZ_Plane (Plan de base).
  5. Appuyez sur OK.

Propriétés

Voir Propriétés pour tous les types de propriétés que les objets scriptés peuvent avoir.

Un Sketcher SketchObject (classe Sketcher::SketchObject) est dérivé de Part Part2DObject (classe Part::Part2DObject) donc partage toutes les propriétés de ce dernier.

Outre les propriétés décrites dans Part Part2DObject, l'objet de base Sketcher SketchObject possède les propriétés suivantes dans l'éditeur de propriétés. Les propriétés masquées peuvent être affichées en utilisant la commande Show all dans le menu contextuel de l'éditeur de propriétés.

Données

Attachment

  • DonnéesMap Mode, DonnéesMap Reversed, DonnéesAttachment Offset comme Part Part2DObject. Voir Part Attachement pour plus d'informations sur tous les modes de mappage de pièces jointes.

Sketch

  • DataConstraints: les contraintes nommées, si elles existent sinon c'est une liste vide [].

Propriétés cachées de Données

Voir Part Part2DObject pour le reste des propriétés masquées.

Base

  • DonnéesProxy (PythonObject): classe personnalisée associée à cet objet. Cela n'existe que pour la version Python. Voir Script.

Sketch

  • DonnéesGeometry (GeometryList): liste des géométries de pièce qui existent à l'intérieur de l'esquisse.
  • DonnéesGéométrie externe (LinkSubList): liste des géométries de pièce en dehors de cette esquisse qui sont utilisées comme référence.

Vue

Auto Constraints

  • ViewAutoconstraints (Bool): si True, il essaiera de définir des contraintes lors du tracé de la géométrie.

Visibility automation

  • ViewEditing Workbench (String): nom du workbench à activer lors de la modification de l'esquisse. Valeur par défaut SketcherWorkbench.
  • ViewHide Dependent (Bool): si True, tous les objets qui dépendent de l'esquisse sont masqués lors de l'ouverture de l'esquisse.
  • ViewRestore Camera (Bool): si True la position de la caméra est enregistrée avant l'ouverture de l'esquisse et est restaurée après sa fermeture.
  • ViewShow Links (Bool): si True, tous les objets utilisés dans les liens vers une géométrie externe sont affichés lors de l'ouverture de l'esquisse.
  • ViewShow Support (Bool): si True tous les objets auxquels cette esquisse est attachée sont affichés lors de l'ouverture de l'esquisse.

Propriétés cachées de Vue

Base

  • DonnéesProxy (PythonObject): classe personnalisée associée à cet objet. Cela n'existe que pour la version Python. Voir Script.

Visibility automation

  • VueTempo Vis (PythonObject): classe personnalisée associée à cet objet qui gère le masquage et l'affichage d'autres objets lors de l'ouverture et de la fermeture de l'esquisse.

Toutes les autres propriétés de vue, y compris les propriétés masquées, sont celles de l'objet de base Part Feature

Création de scripts

Voir aussi: FreeCAD Script de base et objet scripté.

Voir Part Feature pour les informations générales sur l'ajout d'objets au document.

Un SketchObject est créé avec la méthode addObject() du document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"

Ce Sketcher::SketchObject de base n'a pas d'objet Proxy, il ne peut donc pas être entièrement utilisé pour la sous-classification.

Par conséquent, pour la sous-classe Python, vous devez créer l'objet Sketcher::SketchObjectPython.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObjectPython", "CustomSketch")
obj.Label = "Custom label"